IF NOT EXIST meerkat-api.jar GOTO ERROR

IF NOT EXIST build mkdir build

javac -cp meerkat-api.jar -d build -sourcepath src src\ca\ualberta\cs\poker\free\client\*.java

javac -cp meerkat-api.jar -d build -sourcepath src src\ca\ualberta\cs\poker\free\server\*.java

javac -cp meerkat-api.jar -d build -sourcepath src src\ca\ualberta\cs\poker\free\dynamics\*.java

javac  -cp meerkat-api.jar -d build -sourcepath src src\ca\ualberta\cs\poker\free\academy25\*.java

javac  -cp meerkat-api.jar -d build -sourcepath src src\ca\ualberta\cs\poker\free\tournament\*.java

IF NOT EXIST dist mkdir dist



jar cf dist\pokerserver.jar -C build ca


javac -d examples\academy25client -sourcepath examples\academy25client -cp meerkat-api.jar;dist\pokerserver.jar examples\academy25client\TestPlayer.java


jar cf examples\academy25client\TestPlayer.jar -C examples\academy25client TestPlayer.class





IF NOT EXIST docs mkdir docs

javadoc -sourcepath src -d docs -subpackages ca



copy dist\pokerserver.jar examples\randomclient

copy dist\pokerserver.jar examples\academy25client

copy meerkat-api.jar examples\academy25client

copy dist\pokerserver.jar examples\server

GOTO END

:ERROR
@ECHO ERROR: meerkat-api.jar is not here!
@ECHO Please download the Meerkat API 2.5 from 
@ECHO http://www.poker-academy.com/downloads/Meerkat-API-2.5.zip
@ECHO Unzip the contents, and place a copy of 
@ECHO meerkat-api.jar in this directory.
:END

@ECHO Process completed. Note that there are known javadoc
@ECHO errors which should not cause a concern.