package ca.ualberta.cs.poker.free.server;

import java.io.IOException;
import java.io.InputStream;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.security.SecureRandom;

import sun.misc.Cleaner;

import com.sun.corba.se.spi.activation.Server;

public class RunTournament {

	/**
	 * @param args
	 * @throws InterruptedException 
	 */
	public static void main(String[] args) throws InterruptedException {
		// check for necessary files
		// client list
		// client order
		// card files

		// start server
		// launch clients in proper order

		InetAddress client1;
		InetAddress client2;
		String localhost = "127.0.0.1";
		String bellis = "129.128.23.142";

		try {

			client1 = InetAddress.getByName(localhost);
			client2 = InetAddress.getByName(localhost);

			runMatch(1, 2, client1, client1);

		} catch (UnknownHostException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	public static void runMatch(int compNum1, int compNum2,
			InetAddress client1, InetAddress client2)
			throws InterruptedException {

		String[] cmd1 = new String[3];
		String[] cmd2 = new String[3];
		String user = "chsmith";
		String user2 = "chsmith";
		String directory1 = "comp" + compNum1;
		String directory2 = "comp" + compNum2;

		// for some reason toString is adding a \  remove it
		String client1Str = client1.toString().substring(1, client1.toString().length());
		String client2Str = client2.toString().substring(1, client2.toString().length());
		
		// the ' is so cygwin will interpret the two commands in one go
		String command1 = "'cd comp1; ./startme.bat " + client1Str + " ";// + port + "'";
		String command2 = "'cd comp2; ./startme.bat " + client2Str + " ";// + port + "'";
		
		// cmd.exe /C is so the directory slashes are interpreted correctly
		cmd1[0] = "cmd.exe ";
		cmd1[1] = "/C ";
		cmd1[2] = "ssh " + user + "@" + client1Str + " " + command1;

		cmd2[0] = "cmd.exe ";
		cmd2[1] = "/C ";
		cmd2[2] = "ssh " + user2 + "@" + client1Str + " " + command2;
		
		// Before we copy the client and start the clients, lets clean the machine
		String taskKillCommand1 = "ssh " + user + "@" + client1Str + " " + cmd1[0] +  cmd1[1] + "taskkill.exe /F /FI \"USERNAME eq " + user + "\"";
		String taskKillCommand2 = "ssh " + user2 + "@" + client2Str + " " + cmd2[0] +  cmd2[1] + "taskkill.exe /F /FI \"USERNAME eq " + user2 + "\"";
		
		String taskCleanCommand1 = "ssh " + user + "@" + client1Str + " " + "rm -rf ~/" + directory1;
		String taskCleanCommand2 = "ssh " + user2 + "@" + client2Str + " " + "rm -rf ~/" + directory2;
		
		// taskkill all the processes, and clear the directories
		// function'ified for easy on/off
		//cleanMachines( taskKillCommand1, taskKillCommand2, taskCleanCommand1, taskCleanCommand2);
		

		// Copy over the files needed to run each client
		// must be in directories relative to where RunTournament is being run
		// scp -r localfiles user@host:dir
		String scpCommand1 = "scp -r " + directory1 + " " + user + "@" + client1Str + ":~";
		String scpCommand2 = "scp -r " + directory2 + " " + user + "@" + client2Str + ":~";


		try {

			// copy both clients to the client machines with scp
			Process scpChild1 = Runtime.getRuntime().exec(scpCommand1);
			Process scpChild2 = Runtime.getRuntime().exec(scpCommand2);
			System.out.println("Copying client files...");
			System.out.println("SCP1 command = " + scpCommand1);
			System.out.println("SCP2 command = " + scpCommand2);

			
			// setup server
			SecureRandom random = new SecureRandom();
			PokerServer server = new PokerServer(random, client1, client2, 7000);

			System.out.println("\n\nStarting server...");
			
			Thread serverThread = new Thread(server);
			serverThread.start();

			// launch server, wait for clients
			while (server.socket == null) {
				Thread.currentThread().sleep(1000);
				System.out.println("one second");
			}

			// if port is null, something went horribly wrong
			if ( server.socket.getLocalPort() == 0) {
				System.err.println( "Error getting port from server" );
				System.exit(-1);
			}
			
			System.out.println("Server reports port: " + server.socket.getLocalPort());
			
			
			//launch each client with ssh
			
			String client1Exec = cmd1[0] + cmd1[1]  + cmd1[2] + server.socket.getLocalPort() + "'";
			Process clientChild1 = Runtime.getRuntime().exec(client1Exec);

			String client2Exec = cmd2[0] + cmd2[1] + cmd2[2] + server.socket.getLocalPort() + "'";
			Process clientChild2 = Runtime.getRuntime().exec(client2Exec);

			System.out.println("Exec cmd1 = " + client1Exec);
			System.out.println("Exec cmd2 = " + client2Exec);

			

			//Get the input stream and read from it
			InputStream in = clientChild1.getInputStream();
			int c;
			String str = "";
			while ((c = in.read()) != -1) {
				str += (char) c;
			}
			in.close();

			System.out.println("Client 1 Output: " + "\n-----------------------" + str);
			
			InputStream in2 = clientChild2.getInputStream();

			str = "";
			while ((c = in2.read()) != -1) {
				str += (char) c;
			}
			in2.close();

			System.out.println("\n^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^\n" );
			System.out.println("Client 2 Output: " + "\n-----------------------" + str);


			
		} catch (IOException e) {
			System.err.println("Error reading from child stream");
		}

		
		
		System.out.println("RunTournament exiting");
		System.exit(0);
	}

	/**
	 * Make this a function so we can turn on/off the "cleaning" easily, because killing
	 * every process on the machine I'm working on, isn't optimal
	 * 
	 * @param taskKillCommand1
	 * @param taskKillCommand2
	 * @param taskCleanCommand1
	 * @param taskCleanCommand2
	 */
	public static void cleanMachines( String taskKillCommand1, String taskKillCommand2, String taskCleanCommand1, String taskCleanCommand2 ) {
		
		System.out.println( "Clean commands:");
		System.out.println( taskKillCommand1 );
		System.out.println( taskKillCommand2 );
		System.out.println( taskCleanCommand1 );
		System.out.println( taskCleanCommand2 );
		
		// TASKILL everything by the user
		// blow away the directory we're going to be adding
		try {
			
			Process clientCleaner1 = Runtime.getRuntime().exec(taskKillCommand1);
			Process clientCleaner2 = Runtime.getRuntime().exec(taskKillCommand2);
			Process clientCleaner3 = Runtime.getRuntime().exec(taskCleanCommand1);
			Process clientCleaner4 = Runtime.getRuntime().exec(taskCleanCommand2);
			
			
			
			
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			System.err.println( "Failure trying to clean client machines");
			e1.printStackTrace();
		}
		
	}
	
	public void launchClient() {
	}

	public void exec() {
	}

}
